//-------------------------------------------------------------------
//!ۃEBhENX\[X
//!@memo 08/05/09 mmm
//-------------------------------------------------------------------

#include "MMMAWindow.h"
#include <algorithm>

namespace mmm
{
	//!EBhE̓o^pRei
	std::list<AWindow*> AWindow::windowList_;

	namespace
	{
		//!EBhEnhƂ̔rpqIuWFNg
		class IsThisHandle
		{
		public:
			bool operator ()(AWindow* p) const { return hWnd_ == p->GetHandle(); }
			HWND hWnd_;
		};
	}

	//!ŏɌĂ΂O[oȃvV[W֐
	//!o^ĂEBhE̒nhŌČΏϏ
	LRESULT CALLBACK AWindow::GlobalProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
	{
		IsThisHandle is; is.hWnd_ = hWnd;
		std::list<AWindow*>::iterator iW = std::find_if(windowList_.begin(), windowList_.end(), is);
		if(iW != windowList_.end())
			return (*iW)->MyProc(hWnd, msg, wParam, lParam);
		else
			return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	//!EBhENX̓o^֐
	bool AWindow::Register(HINSTANCE hInst)
	{
		WNDCLASSEX wc;
		wc.cbSize = sizeof(WNDCLASSEX);
		wc.style = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
		wc.lpfnWndProc = AWindow::GlobalProc;
		wc.cbClsExtra = 0;
		wc.cbWndExtra = 0;
		wc.hInstance = hInst;
		wc.hCursor = LoadCursor(0, IDC_ARROW);
		wc.hIcon = LoadIcon(0, IDI_WINLOGO);
		wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
		wc.lpszMenuName = 0;
		wc.lpszClassName = GetRegisterName();
		wc.hIconSm = 0;

		if(RegisterClassEx(&wc) == 0)
		{
			return false;
		}

		return true;
	}
	//!EBhE̐֐@Register()Ă邱ƂO
	bool AWindow::Create(HINSTANCE hInst)
	{
		hWnd_ = CreateWindowEx(GetStyleEx(), GetRegisterName(), "", GetStyle(), 0, 0, 0, 0, 0, 0, hInst, 0);
		if(hWnd_ == 0)
		{
			return false;
		}

		return true;
	}
	//!EBhẼXN[TCYiNCAg̈̑傫jݒ֐@ɌĂԂ
	void AWindow::SetScreenSize(int w, int h)
	{
		RECT rect, prev;
		SetRect(&rect, 0, 0, w, h);
		GetWindowRect(hWnd_, &prev);
		AdjustWindowRectEx(&rect, GetStyle(), FALSE, GetStyleEx());
		const int width = rect.right - rect.left;
		const int height = rect.bottom - rect.top;

		MoveWindow(hWnd_, prev.left, prev.top, width, height, true);
	}
	//!EBhËʒuʒSɈړ֐@ɌĂԂ
	void AWindow::MoveDisplayCenter()
	{
		RECT rect;
		GetWindowRect(hWnd_, &rect);
		AdjustWindowRectEx(&rect, GetStyle(), FALSE, GetStyleEx());
		const int width = rect.right - rect.left;
		const int height = rect.bottom - rect.top;

		//Sʒuւ̈ړʂ߂
		HDC hDC = GetDC(0);
		const int scrWidth = GetDeviceCaps(hDC, HORZRES);
		const int scrHeight = GetDeviceCaps(hDC, VERTRES);
		ReleaseDC(0, hDC);
		const int x = scrWidth/2 - (width / 2);
		const int y = scrHeight/2 - (height / 2);

		MoveWindow(hWnd_, x, y, width, height, true);
	}
	//!hNXpWvV[W֐
	LRESULT	CALLBACK AWindow::MyDefProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
	{
		switch(msg)
		{
		case WM_ACTIVATEAPP: active_ = (bool)(wParam != 0); break;
		default: return DefWindowProc(hWnd, msg, wParam, lParam); break;
		};

		return FALSE;
	}
	//!EBhEp֗֐
	bool CreateWindowUTL(mmm::AWindow* pW, HINSTANCE hInst, int w, int h, const LPCSTR pTitle)
	{
		if(pW->Register(hInst) == false) return false;
		if(pW->Create(hInst) == false) return false;
		pW->SetTitle(pTitle);
		pW->SetScreenSize(w, h);
		pW->MoveDisplayCenter();
		pW->Open();

		return true;
	}
};