//-------------------------------------------------------------------
//!tHg쐬Tv\[X
//!@memo 08/05/19 mmm
//-------------------------------------------------------------------

//-------------------------------------------------------------------
#include <windows.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <tchar.h>
#include <stdarg.h>
#include "MMMAWindow.h"
#include "MMMAAppBase.h"

//-------------------------------------------------------------------
#define	WINDOW_TITLE	"eXgEBhE"	//!<^Cg
#define	SCREEN_WIDTH	640					//!<
#define	SCREEN_HEIGHT	480					//!<c

//-------------------------------------------------------------------
static LPDIRECT3D9 g_pD3D_ = 0;				//!<cRcIuWFNg
static LPDIRECT3DDEVICE9 g_pDevice_ = 0;	//!<foCX|C^
static LPD3DXFONT g_pFont_ = 0;				//!<tHgIuWFNgւ̃|C^

//DirectXIuWFNg̉p}N
#define SafeReleaseD3D(p) if((p) != 0){ (p)->Release(); (p) = 0; }

//----------------------------------------------------------
//!tHg֐
//----------------------------------------------------------
bool CreateFont(LONG width, LONG height, LONG weight, const char* faceName)
{
	D3DXFONT_DESC fd;
	fd.Width = width;
	fd.Height = height;
	fd.Weight = weight;
	fd.MipLevels = D3DX_DEFAULT;
	fd.Italic = FALSE;
	fd.CharSet = DEFAULT_CHARSET;
	fd.OutputPrecision = OUT_DEFAULT_PRECIS;
	fd.Quality = DEFAULT_QUALITY;
	fd.PitchAndFamily = DEFAULT_PITCH;
	strcpy_s(fd.FaceName, faceName);

	if(FAILED(D3DXCreateFontIndirect(g_pDevice_, &fd, &g_pFont_)))
	{
		return false;
	}

	return true;
}
//----------------------------------------------------------
//!tHg֐
//----------------------------------------------------------
void ReleaseFont()
{
	SafeReleaseD3D(g_pFont_);
}
//----------------------------------------------------------
//!`֐
//----------------------------------------------------------
static void DrawText(float x, float y, int dtFormat, DWORD color, const char* format, ...)
{
	char va_str[512];
	va_list list;
	va_start(list, format);
	vsprintf_s(va_str, format, list);

	RECT rect;
	SetRect(&rect, (int)x, (int)y, SCREEN_WIDTH, SCREEN_HEIGHT);

	g_pFont_->DrawText(0, va_str, -1, &rect, dtFormat, color);
}

//-------------------------------------------------------------------
//!D3DIuWFNg̐֐
//-------------------------------------------------------------------
static bool CreateD3D(HWND hWnd)
{
	//cRcIuWFNg̐
	g_pD3D_ = Direct3DCreate9(D3D_SDK_VERSION);
	if(g_pD3D_ == NULL) return false;

	//foCX̐pp[^̏
	D3DPRESENT_PARAMETERS pp; 
	ZeroMemory(&pp, sizeof(pp));
	pp.Windowed = TRUE;	
	pp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	pp.BackBufferFormat = D3DFMT_UNKNOWN;
	pp.BackBufferWidth = SCREEN_WIDTH;
	pp.BackBufferHeight = SCREEN_HEIGHT;

	//foCX̐
	if(FAILED(g_pD3D_->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
										D3DCREATE_SOFTWARE_VERTEXPROCESSING, &pp, &g_pDevice_)))
	{
		return false;
	}

	return true;
}
//-------------------------------------------------------------------
//!D3DIuWFNg̉֐
//-------------------------------------------------------------------
static bool ReleaseD3D()
{
	SafeReleaseD3D(g_pD3D_);
	SafeReleaseD3D(g_pDevice_);

	return true;
}

//-------------------------------------------------------------------
//!CEBhENX
//-------------------------------------------------------------------
class MainWindow : public mmm::AWindow
{
public:
	MainWindow()
	{
		//TODO:ŃX^CȂǂݒ
		SetStyle(WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX);
		SetStyleEx(0);
		SetRegisterName("TEST");
	}
	~MainWindow(){}
private:
	virtual LRESULT	CALLBACK MyProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
	{
		//TODO:ł̃NXp̃vV[W`
		switch(msg)
		{
		case WM_DESTROY: PostQuitMessage(0); break;
		default: return AWindow::MyDefProc(hWnd, msg, wParam, lParam); break;
		};

		return	FALSE;
	}
};
//-------------------------------------------------------------------
//!eXgp̃AvP[VNX
//-------------------------------------------------------------------
class TestApp : public mmm::AAppBase
{
public:
	TestApp(){}
	virtual ~TestApp(){}
private:
	virtual bool Init()
	{
		//CEBhE
		if(CreateMyWindow(&mainWnd_, SCREEN_WIDTH, SCREEN_HEIGHT, WINDOW_TITLE) == false) return false;

		//D3DIuWFNg
		if(FAILED(CreateD3D(mainWnd_.GetHandle()))) return false;

		//tHg̐
		if(CreateFont(0, 18, 0, "MS@") == false) return false;

		return true;
	}
	virtual int Update()
	{
		//IʒmĂI
		if(IsQuit()) return UPDATE_EXIT;
		if(mainWnd_.IsActive() == false) return UPDATE_PAUSE;

		//`揈s
		Render();

		return UPDATE_RUN;
	}
	virtual bool Release()
	{
		//tHg̉
		ReleaseFont();

		//D3DIuWFNg
		ReleaseD3D();
		
		return true;
	}
	//!`֐
	void Render()
	{
		if(g_pDevice_ == 0) return;

		//obNobt@NA
		g_pDevice_->Clear(0, 0, D3DCLEAR_TARGET, D3DCOLOR_XRGB(64, 64, 64), 1.0f, 0);
 
		//`Jn̐錾
		if(SUCCEEDED(g_pDevice_->BeginScene()))
		{
			//Ƃ肠"hellow world."`
			DrawText(0, 0, 0, 0xffffffff, "hello world.");
		}
		//`I̐錾
		g_pDevice_->EndScene();

		//obNobt@tgobt@ɏo
		g_pDevice_->Present(NULL, NULL, NULL, NULL);
	}
private:
	MainWindow mainWnd_;		//!<CEBhE
};
//-------------------------------------------------------------------
//!Windows ProgrammingɂĈԍŏɌĂ΂֐
//-------------------------------------------------------------------
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpszCmdLine, int nCmdShow)
{
	hPrevInst;
	lpszCmdLine;
	nCmdShow;

	int exit = 0;
	{
		TestApp app;
		app.Run(hInst);
		exit = app.GetExitCode();
	}
	return exit;
}